> For the complete documentation index, see [llms.txt](https://docs.tensorleap.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tensorleap.ai/tensorleap-integration/leap.yaml.md).

# leap.yaml

Descirbes the leap.yaml configuration - it's fields and usage

The `leap.yaml` configuration file is located at the project root. It is a mandatory configuration file that contains several pieces of information required by the Tensorleap server:

* `projectID`: (optional) an ID that represents a [project](/user-interface/project.md) in the Tensorleap platform.
* `secretID`: (optional) an ID that represents a [secret](/user-interface/secrets-management.md) in the Tensorleap platform.
* `entryFile`: The path to a python file that includes the [tensorleap integration test](/tensorleap-integration/integration-test.md)
* An indicator of which files should be sent to the server relative to the current path. &#x20;
  * `include`: a list of relative file path to upload to the server.
  * `exclude`: a list of relative file path to ignore from server upload.&#x20;

{% hint style="info" %}
Both the `include` and `exclude` fields support wildcards (e.g. `*.py`)
{% endhint %}

* `pythonVersion`: The expected python version to build your dependencies file with when supplying a requirements.txt file.

This stateful configuration allows the [CLI](/tensorleap-integration/uploading-with-cli/cli-assets-upload.md) to know which object it should upload the assets to when communicating with the server.&#x20;

### `leap.yaml` Example

#### Include Example

The leap.yaml can use the `include`  syntax to state which files should be uploaded to the platform

```yaml
projectId: 685474990d49a6e4c09ec115
secretId: ""
entryFile: leap_binder.py
include:
    - leap_binder.py
    - mnist/config.py
    - mnist/project_config.yaml
    - mnist/utils.py
    - mnist/data/preprocess.py
    - requirements.txt
pythonVersion: py310
```

#### Exclude Example:

The leap.yaml can use the `exclude`  syntax to state which files should be uploaded to the platform

```
projectId: 685474990d49a6e4c09ec115
secretId: ""
entryFile: leap_binder.py
exclude:
  - "**/*.h5"
  - "**/*.onnx"
  - "**/*.jpg"
  - "**/*.png"
pythonVersion: py310
```

{% hint style="info" %}
For initial integration or when uploading the code-base and model to a new location, the `leap.yaml` should not include `codeIntegrationId`, `projectId`, `secretId`, and `pythonVersion` rows. During the CLI upload process, you can select these objects interactively, and they will be automatically added to `leap.yaml`.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/leap.yaml.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
